module KFile
	require "fileutils"
	
	def self.delete(dir)
		FileUtils.rm_r(dir) if File.exists? dir
	end
	
	def self.clear(dir)
		FileUtils.rm_r Dir.glob("#{dir}/*")
	end
	
	def self.copy(src,dest)
		return if !File.exists? src
		if File.directory? src
			Dir.mkdir(dest) if !File.exist? dest
			Dir.foreach(src) do |path|
				if path !="." and path !=".."
					copy(src+"/"+path,dest+"/"+path)
				end
			end
		else
			FileUtils.cp(src,dest)
		end
	end
	
	def self.list(dir,recursive = true,&proc)
		return if !File.exists? dir
		if File.directory?(dir)
			Dir.foreach(dir) do |path|
				if path !="." && path !=".."
					full_path = dir + "/" + path
					if recursive
						list(full_path,recursive,&proc)
					else
						yield full_path
					end
				end
			end
		else
			yield dir
		end
	end
	
	def self.read(file_path,encoding = 'utf-8')
		File.open(file_path,"r:#{encoding}"){|f|
			return f.read
		}
	end
	
end

